(() => {
  var __defProp = Object.defineProperty;
  var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

  // ../../../build/app/ui/obj/kmwuitoggle.js
  var _b;
  var keymanweb = window.keyman;
  if (!keymanweb) {
    throw new Error("`keyman` global is missing; Keyman Engine for Web script has not been loaded");
  } else if (!((_b = keymanweb.ui) === null || _b === void 0 ? void 0 : _b.name)) {
    try {
      const util = keymanweb.util;
      if (util.isTouchDevice()) {
        throw "";
      }
      const _ToggleUI = class _ToggleUI {
        constructor() {
          this.name = "toggle";
          this.initialized = false;
          this.controller = null;
          this.oskButton = null;
          this.kbdButton = null;
          this.controllerHovered = false;
          this.keyboards = [];
          this.lastActiveKeyboard = -1;
          this.selectedMenuItem = null;
          this.updateList = true;
          this.updateTimer = null;
          this.switchOsk = () => {
            if (keymanweb.getActiveKeyboard() == "" || keymanweb.isCJK()) {
              return;
            }
            if (keymanweb.osk) {
              const newState = !keymanweb.osk.isEnabled();
              keymanweb.osk.show(newState);
              this.oskButton._setSelected(newState);
            }
          };
          this.switchSingleKbd = () => {
            const _v = keymanweb.getActiveKeyboard() == "";
            let nLastKbd = 0, kbdName = "", lgCode = "";
            if (_v) {
              if (this.keyboards.length == 0) {
                return;
              }
              if (this.lastActiveKeyboard < this.keyboards.length && this.lastActiveKeyboard >= 0) {
                nLastKbd = this.lastActiveKeyboard;
              }
              kbdName = this.keyboards[nLastKbd]._InternalName;
              lgCode = this.keyboards[nLastKbd]._LanguageCode;
              keymanweb.setActiveKeyboard(kbdName, lgCode);
              this.lastActiveKeyboard = nLastKbd;
            } else {
              keymanweb.setActiveKeyboard("");
            }
            if (this.kbdButton) {
              this.kbdButton._setSelected(_v);
            }
          };
          this.switchNextKbd = () => {
            let _v = keymanweb.getActiveKeyboard() == "";
            let kbdName = "", lgCode = "";
            if (_v) {
              if (this.keyboards.length == 0) {
                return;
              }
              kbdName = this.keyboards[0]._InternalName;
              lgCode = this.keyboards[0]._LanguageCode;
              keymanweb.setActiveKeyboard(kbdName, lgCode);
              this.lastActiveKeyboard = 0;
            } else {
              if (this.lastActiveKeyboard == this.keyboards.length - 1) {
                keymanweb.setActiveKeyboard("");
                _v = false;
              } else {
                kbdName = this.keyboards[++this.lastActiveKeyboard]._InternalName;
                lgCode = this.keyboards[this.lastActiveKeyboard]._LanguageCode;
                keymanweb.setActiveKeyboard(kbdName, lgCode);
                _v = true;
              }
            }
            if (this.kbdButton) {
              this.kbdButton._setSelected(_v);
            }
          };
          this.updateKeyboardList = () => {
            if (!(keymanweb.initialized || this.initialized)) {
              return;
            }
            this.updateList = false;
            const _kbds = keymanweb.getKeyboards();
            const imgPath = util.getOption("resources") + "ui/toggle/";
            if (_kbds.length > 1) {
              const _kmw_ctrl_img = document.getElementById("KMW_Controller_Img");
              _kmw_ctrl_img.src = imgPath + "kmw_logo_16_down.gif";
              _kmw_ctrl_img.style.width = "100%";
              this.controller.style.background = "url(" + imgPath + "kmwcontroller2x.gif)";
              this.kbdButton.getElem().id = "kmwico";
              this.kbdButton.getElem().style.width = "36px";
              this.kbdButton._onmouseover = () => {
                this.keyboardMenu.className = "sfhover";
              };
              this.kbdButton._onmouseout = () => {
                this.keyboardMenu.className = "sfunhover";
              };
              this.kbdButton._onclick = null;
              this.createMenu();
            } else if (_kbds.length == 1) {
              const _kmw_ctrl_img = document.getElementById("KMW_Controller_Img");
              _kmw_ctrl_img.src = imgPath + "kmw_logo_16.gif";
              this.kbdButton.getElem().id = "kmwico";
              this.kbdButton.getElem().style.width = "24px";
              var Lki = _kbds[0].InternalName;
              var Lklc = _kbds[0].LanguageCode;
              this.controller.style.background = "url(" + imgPath + "kmwcontroller2.gif)";
              this.keyboards.push({ _InternalName: Lki, _LanguageCode: Lklc, _Index: 0 });
              this.kbdButton._onclick = this.switchSingleKbd;
              this.kbdButton._onmouseover = function() {
              };
              this.kbdButton._onmouseout = function() {
              };
              this.createMenu();
              if (typeof this.keyboardMenu != "undefined") {
                delete this.keyboardMenu;
              }
            }
            var sk = keymanweb.getSavedKeyboard().split(":");
            this.updateMenu(sk[0], sk[1]);
          };
        }
        /**
         * Update the KeymanWeb user interface when an input element is focused or blurred
         *
         * @param       {Object}            someElement     focused element
         * @param       {(boolean|number)}  focusing        true if focusing
         * @param       {Object}            activeControl   Object representing API specs for the control, if it exists and is now focused.
         */
        doFocus(someElement, focusing, activeControl) {
          if (!this.initialized) {
            return;
          }
          if (window.event && keymanweb.isAttached(window.event.srcElement)) {
            someElement = window.event.srcElement;
          }
          if (focusing) {
            this.controller.style.display = "block";
          } else {
            if (!keymanweb.getUIState().activationPending && !this.controllerHovered) {
              this.controller.style.display = "none";
            }
          }
          let w, h;
          const p = util.getAbsolute(someElement);
          let x = p.x;
          let y = p.y;
          var ownerDoc = someElement.ownerDocument;
          if (ownerDoc.designMode == "on" && ownerDoc.defaultView && ownerDoc.defaultView.frameElement) {
            w = ownerDoc.defaultView.frameElement.clientWidth;
            h = ownerDoc.defaultView.frameElement.clientHeight;
          } else {
            w = someElement.offsetWidth;
            h = someElement.offsetHeight;
          }
          if (x + w > window.innerWidth + document.documentElement.scrollLeft - this.controller.offsetWidth - 1) {
            y += h;
          } else {
            x += w + 2;
            y += h - 29;
          }
          if (isNaN(x) || isNaN(y)) {
            return;
          }
          this.controller.style.left = x + "px";
          this.controller.style.top = y + "px";
        }
        registerEvents() {
          let osk = keymanweb.osk;
          if (!osk) {
            return;
          }
          osk.addEventListener("show", (oskPosition) => {
            this.controller.style.display = "block";
            this.oskButton._setSelected(true);
            return oskPosition;
          });
          osk.addEventListener("hide", (byUser) => {
            if (byUser["HiddenByUser"]) {
              this.oskButton._setSelected(false);
            }
          });
        }
        /**
         * Create a button object for KeymanWeb UI buttons
         *
         * @constructor
         * @param       {string}    _src         Image source
         * @param       {string}    _caption     Alt text
         * @param       {boolean}   _selected
         * @return      {Object}
         *
         * @suppress {suspiciousCode}  // Closure isn't smart enough to realize that _onmouseover
         *                             // and the like are defined on individual instances later.
         *                             // It thinks they're always null.
         **/
        button(_src, _caption, _selected) {
          const ui2 = this;
          const _Button = class _Button {
            getElem() {
              return this._elem;
            }
            __updatestyle() {
              var ss = this._elem.style;
              if (this._over) {
                ss.margin = "0px";
                if (this._selected) {
                  ss.border = "solid 1px #ad4a28";
                  ss.background = "#dfb4b4";
                } else {
                  ss.border = "solid 1px #dfb4b4";
                  ss.background = "#f3e5de";
                }
              } else if (this._selected) {
                ss.background = "#f3e5de";
                ss.margin = "0px";
                ss.border = "solid 1px #ad4a28";
              } else {
                ss.background = "none";
                ss.margin = "1px";
                ss.border = "none";
              }
            }
            _setSelected(_value) {
              keymanweb.activatingUI(false);
              this._selected = _value;
              this.__updatestyle();
            }
            _getSelected() {
              return this._selected;
            }
            _getOver() {
              return this._over;
            }
            _getDown() {
              return this._down;
            }
            constructor() {
              this._onclick = null;
              this._onmouseover = null;
              this._onmouseout = null;
              this._down = false;
              this._over = false;
              this.__mouseover = () => {
                ui2.controllerHovered = true;
                this._over = true;
                if (this._onmouseover != null) {
                  this._onmouseover();
                }
                this.__updatestyle();
              };
              this.__mouseout = () => {
                ui2.controllerHovered = false;
                this._over = false;
                if (this._onmouseout != null) {
                  this._onmouseout();
                }
                this.__updatestyle();
              };
              this.__click = () => {
                keymanweb.activatingUI(false);
                if (this._onclick != null) {
                  return this._onclick();
                }
                return false;
              };
              this.__mousedown = () => {
                keymanweb.activatingUI(true);
                this._down = true;
                this.__updatestyle();
                return false;
              };
              this.__mouseup = () => {
                this._down = false;
                this.__updatestyle();
              };
              this._selected = _selected;
              let imgPath = util.getOption("resources") + "ui/toggle/";
              let _elemImg = util.createElement("img");
              this._elem = util.createElement("div");
              this._elem["_owningObject"] = this;
              _elemImg.style.display = "block";
              _elemImg.src = imgPath + _src;
              _elemImg.id = "KMW_Controller_Img";
              this._elem.style.margin = "0px";
              this._elem.style.width = "24px";
              this._elem.style.height = "24px";
              this._elem.style.zIndex = "10002";
              this._elem.style.lineHeight = "100%";
              this._elem.style.cssFloat = "left";
              _elemImg.title = _caption;
              _elemImg.alt = _caption;
              this._elem.appendChild(_elemImg);
              this._elem.onmouseover = this.__mouseover;
              this._elem.onmouseout = this.__mouseout;
              this._elem.onmousedown = this.__mousedown;
              this._elem.onmouseup = this.__mouseup;
              _elemImg["_owningObject"] = this;
              _elemImg.onclick = this.__click;
              this.__updatestyle();
            }
          };
          __name(_Button, "Button");
          let Button = _Button;
          return new Button();
        }
        /**
         * Function     Initialize
         * Scope        Private
         * Description  Initialize Toggle User Interface
         **/
        initialize() {
          if (!keymanweb.initialized || util.isTouchDevice()) {
            return;
          }
          if (!this.initialized) {
            this.controller = util.createElement("div");
          } else {
            this.controller.innerHTML = "";
          }
          const imgPath = util.getOption("resources") + "ui/toggle/";
          this.controller.style.background = "url(" + imgPath + "kmwcontroller2x.gif)";
          this.controller.style.padding = "1px 2px";
          const v1 = util.loadCookie("KeymanWeb_Keyboard");
          let kbdEnabledOnLoad = false;
          if (typeof v1.current != "undefined") {
            kbdEnabledOnLoad = v1.current.indexOf("---") < 0;
          }
          this.kbdButton = this.button("kmw_logo_16.gif", "Use Web Keyboard", kbdEnabledOnLoad);
          this.controller.appendChild(this.kbdButton.getElem());
          const v2 = util.loadCookie("KeymanWeb_OnScreenKeyboard");
          let oskEnabledOnLoad = true;
          if (typeof v2.visible != "undefined") {
            oskEnabledOnLoad = v2.visible == 1;
          }
          this.oskButton = this.button("kmw_osk_16.gif", "Show On Screen Keyboard", oskEnabledOnLoad);
          this.oskButton._onclick = this.switchOsk;
          this.controller.appendChild(this.oskButton.getElem());
          if (!this.initialized) {
            this.controller.style.display = "none";
          }
          this.controller.style.zIndex = "10001";
          this.controller.style.position = "absolute";
          if (!this.initialized) {
            document.body.appendChild(this.controller);
          }
          this.initialized = true;
          this.updateKeyboardList();
          this.registerEvents();
          util.addStyleSheet(this.stylingCSS);
        }
        shutdown() {
          var root = this.controller;
          if (root) {
            root.parentNode.removeChild(root);
          }
        }
        /* ----------------------------------------
          Drop down menu
          ---------------------------------------- */
        //  var  _SelectedMenuItem;
        /**
         * Function     selecKbd
         * Scope        Private
         * @param       {number}  _kbd
         * Description  Select a keyboard from the drop down menu
         **/
        selectKbd(_kbd) {
          let _name, _lgCode;
          if (_kbd < 0) {
            _name = "";
            _lgCode = "";
          } else {
            _name = this.keyboards[_kbd]._InternalName;
            _lgCode = this.keyboards[_kbd]._LanguageCode;
          }
          keymanweb.setActiveKeyboard(_name, _lgCode);
          keymanweb.focusLastActiveElement();
          this.kbdButton._setSelected(_name != "");
          if (_kbd >= 0) {
            this.lastActiveKeyboard = _kbd;
          }
          return false;
        }
        /**
         * Function     updateMenu
         * Scope        Private
         * @param       {string}    kbdName
         * @param       {?string=}  lgCode
         * Description  Updates the menu selection when a change is required
         **/
        updateMenu(kbdName, lgCode) {
          let _k = document.getElementById("KMWSel_$");
          for (let i = 0; i < this.keyboards.length; i++) {
            if (this.keyboards[i]._InternalName == kbdName && this.keyboards[i]._LanguageCode == lgCode) {
              _k = document.getElementById("KMWSel_" + this.keyboards[i]._InternalName + "$" + this.keyboards[i]._Index);
            }
          }
          if (_k) {
            if (this.selectedMenuItem != null) {
              this.selectedMenuItem.className = "";
            }
            _k.className = "selected";
            this.selectedMenuItem = _k;
          }
          if (!this.oskButton) {
            return;
          }
          if (lgCode == "cmn" || lgCode == "jpn" || lgCode == "kor") {
            this.oskButton.getElem().style.display = "none";
          } else if (kbdName == "") {
            this.oskButton.getElem().style.display = "none";
          } else {
            this.oskButton.getElem().style.display = "block";
          }
        }
        get stylingCSS() {
          return `
#KeymanWeb_KbdList {
  display: block;
  position: absolute;
  width: auto;
  line-height: 100%;
  margin: 0;
  clear: both;
  float: none;
  top: auto;
  border: solid 2px #ad4a28;
  -moz-border-radius: 4px;
  -webkit-border-radius: 4px;
  border-radius: 4px;
  box-shadow: 4px 4px 2px rgba(136,136,136,.5);
  -webkit-box-shadow: 4px 4px 2px rgba(136,136,136,.5);
  -moz-box-shadow: 4px 4px 2px rgba(136,136,136,.5);
  list-style: none;
  padding: 0;
  background: white;
  max-height: 300px;
  overflow-y: scroll;
  overflow-x: hidden;
  white-space: nowrap;
  z-index: 10001; /* above the osk */
}

.sfunhover#KeymanWeb_KbdList {
  display: none; left: -999px;
}

.sfhover#KeymanWeb_KbdList {
  display: block;
  left: auto;
}

#KeymanWeb_KbdList li {
  float: none;
  width: auto;
  padding: 0;
  margin: 0;
  text-align: left;
}

#KeymanWeb_KbdList li a {
  display: block;
  padding: 2px 4px;
  color: #404040;
  font-family: Tahoma,Verdana,Arial,sans-serif;
  font-size: 8pt;
  text-decoration: none;
}

#KeymanWeb_KbdList li a.selected {
  font-weight: bold;
  color: black;
}

#KeymanWeb_KbdList li a:hover {
  color: white;
  background-color: #ad4a28;
  text-decoration: underline;
}
`;
        }
        /**
         * Function     createMenu
         * Scope        Private
         * Description  Create the drop down menu and populate with loaded KeymanWeb keyboards
         **/
        createMenu() {
          if (typeof this.keyboardMenu == "undefined") {
            this.keyboardMenu = util.createElement("ul");
            this.keyboardMenu.id = "KeymanWeb_KbdList";
            this.keyboardMenu.className = "sfunhover";
          } else {
            this.keyboardMenu.innerHTML = "";
          }
          var _li = util.createElement("li");
          var _a = util.createElement("a");
          _a.innerHTML = "(System keyboard)";
          _a.href = "#";
          _a.onclick = () => {
            return this.selectKbd(-1);
          };
          _a.id = "KMWSel_$";
          _a.className = "selected";
          _li.appendChild(_a);
          this.selectedMenuItem = _a;
          this.keyboardMenu.appendChild(_li);
          const _kbds = keymanweb.getKeyboards(), _added = {};
          this.keyboards = [];
          for (var _kbd = 0; _kbd < _kbds.length; _kbd++) {
            var _li1 = util.createElement("li");
            var _a1 = util.createElement("a");
            _a1.innerHTML = _kbds[_kbd].LanguageName + " - " + _kbds[_kbd].Name;
            if (!_added[_kbds[_kbd].InternalName])
              _added[_kbds[_kbd].InternalName] = 0;
            _added[_kbds[_kbd].InternalName]++;
            var _n = _added[_kbds[_kbd].InternalName];
            this.keyboards.push({ _InternalName: _kbds[_kbd].InternalName, _LanguageCode: _kbds[_kbd].LanguageCode, _Index: _n });
            _a1.href = "#";
            _a1.onclick = ((x) => {
              return () => this.selectKbd(x);
            })(this.keyboards.length - 1);
            _a1.id = "KMWSel_" + _kbds[_kbd].InternalName + "$" + _n;
            _li1.appendChild(_a1);
            this.keyboardMenu.appendChild(_li1);
          }
          if (this.keyboardMenu.parentNode != this.kbdButton.getElem()) {
            this.kbdButton.getElem().appendChild(this.keyboardMenu);
          }
        }
      };
      __name(_ToggleUI, "ToggleUI");
      let ToggleUI = _ToggleUI;
      const ui = keymanweb.ui = new ToggleUI();
      keymanweb.addHotKey(191, 32, ui.switchSingleKbd);
      keymanweb.addHotKey(191, 48, ui.switchNextKbd);
      keymanweb.addHotKey(191, 64, ui.switchOsk);
      keymanweb.addEventListener("controlfocused", function(params) {
        ui.doFocus(params.target, true, params.activeControl);
      });
      keymanweb.addEventListener("controlblurred", function(params) {
        ui.doFocus(params.target, false, null);
      });
      keymanweb.addEventListener("keyboardregistered", function(p) {
        ui.updateList = true;
        if (ui.updateTimer) {
          clearTimeout(ui.updateTimer);
        }
        ui.updateTimer = window.setTimeout(ui.updateKeyboardList, 200);
      });
      keymanweb.addEventListener("keyboardchange", function(p) {
        ui.updateMenu(p.internalName, p.languageCode);
      });
      ui.initialize();
    } catch (ex) {
    }
  }
})();
//# sourceMappingURL=kmwuitoggle.js.map
