/**
 * May include non-US virtual key codes
 */
export declare const USVirtualKeyCodes: {
    K_BKSP: number;
    K_TAB: number;
    K_ENTER: number;
    K_SHIFT: number;
    K_CONTROL: number;
    K_ALT: number;
    K_PAUSE: number;
    K_CAPS: number;
    K_ESC: number;
    K_SPACE: number;
    K_PGUP: number;
    K_PGDN: number;
    K_END: number;
    K_HOME: number;
    K_LEFT: number;
    K_UP: number;
    K_RIGHT: number;
    K_DOWN: number;
    K_SEL: number;
    K_PRINT: number;
    K_EXEC: number;
    K_INS: number;
    K_DEL: number;
    K_HELP: number;
    K_0: number;
    K_1: number;
    K_2: number;
    K_3: number;
    K_4: number;
    K_5: number;
    K_6: number;
    K_7: number;
    K_8: number;
    K_9: number;
    K_A: number;
    K_B: number;
    K_C: number;
    K_D: number;
    K_E: number;
    K_F: number;
    K_G: number;
    K_H: number;
    K_I: number;
    K_J: number;
    K_K: number;
    K_L: number;
    K_M: number;
    K_N: number;
    K_O: number;
    K_P: number;
    K_Q: number;
    K_R: number;
    K_S: number;
    K_T: number;
    K_U: number;
    K_V: number;
    K_W: number;
    K_X: number;
    K_Y: number;
    K_Z: number;
    K_NP0: number;
    K_NP1: number;
    K_NP2: number;
    K_NP3: number;
    K_NP4: number;
    K_NP5: number;
    K_NP6: number;
    K_NP7: number;
    K_NP8: number;
    K_NP9: number;
    K_NPSTAR: number;
    K_NPPLUS: number;
    K_SEPARATOR: number;
    K_NPMINUS: number;
    K_NPDOT: number;
    K_NPSLASH: number;
    K_F1: number;
    K_F2: number;
    K_F3: number;
    K_F4: number;
    K_F5: number;
    K_F6: number;
    K_F7: number;
    K_F8: number;
    K_F9: number;
    K_F10: number;
    K_F11: number;
    K_F12: number;
    K_NUMLOCK: number;
    K_SCROLL: number;
    K_LSHIFT: number;
    K_RSHIFT: number;
    K_LCONTROL: number;
    K_RCONTROL: number;
    K_LALT: number;
    K_RALT: number;
    K_COLON: number;
    K_EQUAL: number;
    K_COMMA: number;
    K_HYPHEN: number;
    K_PERIOD: number;
    K_SLASH: number;
    K_BKQUOTE: number;
    K_LBRKT: number;
    /**
     * == K_OEM_5, 0xDC
     */
    K_BKSLASH: number;
    K_RBRKT: number;
    K_QUOTE: number;
    /**
     * ISO B00, key to right of left shift, not on US keyboard,
     * 0xE2, K_OEM_102
     */
    K_oE2: number;
    K_OE2: number;
    K_oC1: number;
    K_OC1: number;
    'K_?C1': number;
    'k_?C1': number;
    K_oDF: number;
    K_ODF: number;
    K_LOPT: number;
    K_ROPT: number;
    K_NUMERALS: number;
    K_SYMBOLS: number;
    K_CURRENCIES: number;
    K_UPPER: number;
    K_LOWER: number;
    K_ALPHA: number;
    K_SHIFTED: number;
    K_ALTGR: number;
    K_TABBACK: number;
    K_TABFWD: number;
};
/** Map a CLDR scancode to a US VKey ala USVirtualKeyCodes */
export declare const CLDRScanToUSVirtualKeyCodes: {
    2: number;
    3: number;
    4: number;
    5: number;
    6: number;
    7: number;
    8: number;
    9: number;
    10: number;
    11: number;
    12: number;
    13: number;
    16: number;
    17: number;
    18: number;
    19: number;
    20: number;
    21: number;
    22: number;
    23: number;
    24: number;
    25: number;
    26: number;
    27: number;
    30: number;
    31: number;
    32: number;
    33: number;
    34: number;
    35: number;
    36: number;
    37: number;
    38: number;
    39: number;
    40: number;
    41: number;
    43: number;
    44: number;
    45: number;
    46: number;
    47: number;
    48: number;
    49: number;
    50: number;
    51: number;
    52: number;
    53: number;
    57: number;
    86: number;
    115: number;
    125: number;
};
export type KeyMap = number[][];
/**
 * Convert a scan code numerical KeyMap to VKeys
 * @param scans keymap to convert
 * @param badScans output: set of not-found scancodes
 * @returns
 */
export declare function CLDRScanToKeyMap(scans: KeyMap, badScans?: Set<number>): KeyMap;
/** Convert one scan code to vkey, or undefined */
export declare function CLDRScanToVkey(scan: number, badScans?: Set<number>): number;
//# sourceMappingURL=virtual-key-constants.d.ts.map