import { BUILDER_KVK_SHIFT_STATE, BUILDER_KVK_HEADER_FLAGS, BUILDER_KVK_KEY_FLAGS } from "./kvk-file.js";
/**
 * The default font and size are not very important, as generally they are
 * unused, because font information is provided in the package, but we include
 * them for completeness. The size is included as a negative value which is
 * defined in the LOGFONT structure in Windows API.
 */
export declare const DEFAULT_KVK_FONT: {
    name: string;
    size: number;
};
export declare class VisualKeyboard {
    header: VisualKeyboardHeader;
    keys: VisualKeyboardKey[];
}
export { BUILDER_KVK_HEADER_FLAGS as VisualKeyboardHeaderFlags } from "./kvk-file.js";
export declare class VisualKeyboardHeader {
    version?: number;
    flags: BUILDER_KVK_HEADER_FLAGS;
    associatedKeyboard?: string;
    ansiFont: VisualKeyboardFont;
    unicodeFont: VisualKeyboardFont;
    underlyingLayout?: string;
}
export declare class VisualKeyboardFont {
    name?: string;
    size?: number;
}
export { BUILDER_KVK_KEY_FLAGS as VisualKeyboardKeyFlags } from "./kvk-file.js";
export { BUILDER_KVK_SHIFT_STATE as VisualKeyboardShiftState } from "./kvk-file.js";
export declare class VisualKeyboardKey {
    flags?: BUILDER_KVK_KEY_FLAGS;
    shift?: BUILDER_KVK_SHIFT_STATE;
    vkey?: number;
    text?: string;
    bitmap?: Uint8Array;
}
interface VisualKeyboardLegalShiftState {
    desc: string;
    name: string;
    shift: number;
    vkeys: number[];
}
export declare const VisualKeyboardLegalShiftStates: VisualKeyboardLegalShiftState[];
//# sourceMappingURL=visual-keyboard.d.ts.map