import { OrderedStringList } from './pattern-parser.js';
import { DependencySections, StrsItem, StrsOptions } from '../kmx/kmx-plus/kmx-plus.js';
/**
 * A single entry in a ListItem.
 * Contains a StrsItem as its value.
 */
export declare class ListIndex {
    readonly value: StrsItem;
    constructor(value: StrsItem);
    isEqual(a: ListIndex | string): boolean;
    toString(): string;
}
/**
 * A string list in memory. This will be replaced with an index
 * into the string table at finalization.
 */
export declare class ListItem extends Array<ListIndex> implements OrderedStringList {
    /**
     * Construct a new list from an array of strings.
     * Use List. This is meant to be called by the List.allocString*() functions.
     * @param source array of strings
     * @param opts string handling options
     * @param sections the Strs section is needed to construct this object, and other sections may
     * be needed depending on the options
     * @returns
     */
    static fromStrings(source: Array<string>, opts: StrsOptions, sections: DependencySections): ListItem;
    getItemOrder(item: string): number;
    isEqual(a: ListItem | string[]): boolean;
    compareTo(o: ListItem): number;
    /** for debugging and tests, print as single string */
    toString(): string;
    /** for debugging and tests, map to string array */
    toStringArray(): string[];
}
//# sourceMappingURL=string-list.d.ts.map