/**
 * Parsed UnicodeSet, return value of of parseUnicodeSet()
 */
export class UnicodeSet {
    pattern;
    ranges;
    /**
     * A UnicodeSet in range form.
     * For example, `[ħa-z]` will parse to
     * ranges = `[[0x41, 0x7A], [0x0127, 0x0127]]` meaning `[a,z], [ħ,ħ]`
     * @param pattern the pattern per UnicodeSet syntax such as `[a-z]`
     * @param ranges array of 2-element arrays, 'start' and 'end'.
     */
    constructor(pattern, ranges) {
        this.pattern = pattern;
        this.ranges = ranges;
    }
    /**
     * Number of ranges
     */
    get length() {
        return this.ranges.length;
    }
    toString() {
        return this.pattern;
    }
}
//# sourceMappingURL=unicodeset-parser-api.js.map