var __getOwnPropNames = Object.getOwnPropertyNames;
var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
// ../../../node_modules/ajv-formats/dist/formats.js
var require_formats = __commonJS({
    "../../../node_modules/ajv-formats/dist/formats.js"(exports) {
        "use strict";
        Object.defineProperty(exports, "__esModule", { value: true });
        exports.formatNames = exports.fastFormats = exports.fullFormats = void 0;
        function fmtDef(validate, compare) {
            return { validate, compare };
        }
        exports.fullFormats = {
            // date: http://tools.ietf.org/html/rfc3339#section-5.6
            date: fmtDef(date, compareDate),
            // date-time: http://tools.ietf.org/html/rfc3339#section-5.6
            time: fmtDef(time, compareTime),
            "date-time": fmtDef(date_time, compareDateTime),
            // duration: https://tools.ietf.org/html/rfc3339#appendix-A
            duration: /^P(?!$)((\d+Y)?(\d+M)?(\d+D)?(T(?=\d)(\d+H)?(\d+M)?(\d+S)?)?|(\d+W)?)$/,
            uri,
            "uri-reference": /^(?:[a-z][a-z0-9+\-.]*:)?(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'"()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?(?:\?(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i,
            // uri-template: https://tools.ietf.org/html/rfc6570
            "uri-template": /^(?:(?:[^\x00-\x20"'<>%\\^`{|}]|%[0-9a-f]{2})|\{[+#./;?&=,!@|]?(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?(?:,(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?)*\})*$/i,
            // For the source: https://gist.github.com/dperini/729294
            // For test cases: https://mathiasbynens.be/demo/url-regex
            url: /^(?:https?|ftp):\/\/(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)(?:\.(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)*(?:\.(?:[a-z\u{00a1}-\u{ffff}]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/iu,
            email: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
            hostname: /^(?=.{1,253}\.?$)[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*\.?$/i,
            // optimized https://www.safaribooksonline.com/library/view/regular-expressions-cookbook/9780596802837/ch07s16.html
            ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
            ipv6: /^((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))$/i,
            regex,
            // uuid: http://tools.ietf.org/html/rfc4122
            uuid: /^(?:urn:uuid:)?[0-9a-f]{8}-(?:[0-9a-f]{4}-){3}[0-9a-f]{12}$/i,
            // JSON-pointer: https://tools.ietf.org/html/rfc6901
            // uri fragment: https://tools.ietf.org/html/rfc3986#appendix-A
            "json-pointer": /^(?:\/(?:[^~/]|~0|~1)*)*$/,
            "json-pointer-uri-fragment": /^#(?:\/(?:[a-z0-9_\-.!$&'()*+,;:=@]|%[0-9a-f]{2}|~0|~1)*)*$/i,
            // relative JSON-pointer: http://tools.ietf.org/html/draft-luff-relative-json-pointer-00
            "relative-json-pointer": /^(?:0|[1-9][0-9]*)(?:#|(?:\/(?:[^~/]|~0|~1)*)*)$/,
            // the following formats are used by the openapi specification: https://spec.openapis.org/oas/v3.0.0#data-types
            // byte: https://github.com/miguelmota/is-base64
            byte,
            // signed 32 bit integer
            int32: { type: "number", validate: validateInt32 },
            // signed 64 bit integer
            int64: { type: "number", validate: validateInt64 },
            // C-type float
            float: { type: "number", validate: validateNumber },
            // C-type double
            double: { type: "number", validate: validateNumber },
            // hint to the UI to hide input strings
            password: true,
            // unchecked string payload
            binary: true
        };
        exports.fastFormats = {
            ...exports.fullFormats,
            date: fmtDef(/^\d\d\d\d-[0-1]\d-[0-3]\d$/, compareDate),
            time: fmtDef(/^(?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)?$/i, compareTime),
            "date-time": fmtDef(/^\d\d\d\d-[0-1]\d-[0-3]\d[t\s](?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)$/i, compareDateTime),
            // uri: https://github.com/mafintosh/is-my-json-valid/blob/master/formats.js
            uri: /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/)?[^\s]*$/i,
            "uri-reference": /^(?:(?:[a-z][a-z0-9+\-.]*:)?\/?\/)?(?:[^\\\s#][^\s#]*)?(?:#[^\\\s]*)?$/i,
            // email (sources from jsen validator):
            // http://stackoverflow.com/questions/201323/using-a-regular-expression-to-validate-an-email-address#answer-8829363
            // http://www.w3.org/TR/html5/forms.html#valid-e-mail-address (search for 'wilful violation')
            email: /^[a-z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?)*$/i
        };
        exports.formatNames = Object.keys(exports.fullFormats);
        function isLeapYear(year) {
            return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
        }
        var DATE = /^(\d\d\d\d)-(\d\d)-(\d\d)$/;
        var DAYS = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
        function date(str) {
            const matches = DATE.exec(str);
            if (!matches)
                return false;
            const year = +matches[1];
            const month = +matches[2];
            const day = +matches[3];
            return month >= 1 && month <= 12 && day >= 1 && day <= (month === 2 && isLeapYear(year) ? 29 : DAYS[month]);
        }
        function compareDate(d1, d2) {
            if (!(d1 && d2))
                return void 0;
            if (d1 > d2)
                return 1;
            if (d1 < d2)
                return -1;
            return 0;
        }
        var TIME = /^(\d\d):(\d\d):(\d\d)(\.\d+)?(z|[+-]\d\d(?::?\d\d)?)?$/i;
        function time(str, withTimeZone) {
            const matches = TIME.exec(str);
            if (!matches)
                return false;
            const hour = +matches[1];
            const minute = +matches[2];
            const second = +matches[3];
            const timeZone = matches[5];
            return (hour <= 23 && minute <= 59 && second <= 59 || hour === 23 && minute === 59 && second === 60) && (!withTimeZone || timeZone !== "");
        }
        function compareTime(t1, t2) {
            if (!(t1 && t2))
                return void 0;
            const a1 = TIME.exec(t1);
            const a2 = TIME.exec(t2);
            if (!(a1 && a2))
                return void 0;
            t1 = a1[1] + a1[2] + a1[3] + (a1[4] || "");
            t2 = a2[1] + a2[2] + a2[3] + (a2[4] || "");
            if (t1 > t2)
                return 1;
            if (t1 < t2)
                return -1;
            return 0;
        }
        var DATE_TIME_SEPARATOR = /t|\s/i;
        function date_time(str) {
            const dateTime = str.split(DATE_TIME_SEPARATOR);
            return dateTime.length === 2 && date(dateTime[0]) && time(dateTime[1], true);
        }
        function compareDateTime(dt1, dt2) {
            if (!(dt1 && dt2))
                return void 0;
            const [d1, t1] = dt1.split(DATE_TIME_SEPARATOR);
            const [d2, t2] = dt2.split(DATE_TIME_SEPARATOR);
            const res = compareDate(d1, d2);
            if (res === void 0)
                return void 0;
            return res || compareTime(t1, t2);
        }
        var NOT_URI_FRAGMENT = /\/|:/;
        var URI = /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)(?:\?(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
        function uri(str) {
            return NOT_URI_FRAGMENT.test(str) && URI.test(str);
        }
        var BYTE = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/gm;
        function byte(str) {
            BYTE.lastIndex = 0;
            return BYTE.test(str);
        }
        var MIN_INT32 = -(2 ** 31);
        var MAX_INT32 = 2 ** 31 - 1;
        function validateInt32(value) {
            return Number.isInteger(value) && value <= MAX_INT32 && value >= MIN_INT32;
        }
        function validateInt64(value) {
            return Number.isInteger(value);
        }
        function validateNumber() {
            return true;
        }
        var Z_ANCHOR = /[^\\]\\Z/;
        function regex(str) {
            if (Z_ANCHOR.test(str))
                return false;
            try {
                new RegExp(str);
                return true;
            }
            catch (e) {
                return false;
            }
        }
    }
});
// obj/schemas/keyboard_info.schema.validator.cjs
var require_keyboard_info_schema_validator = __commonJS({
    "obj/schemas/keyboard_info.schema.validator.cjs"(exports, module) {
        module.exports = validate20;
        module.exports.default = validate20;
        var schema23 = { "type": "object", "properties": { "id": { "type": "string" }, "name": { "type": "string" }, "authorName": { "type": "string" }, "authorEmail": { "type": "string", "format": "email" }, "description": { "type": "string" }, "license": { "type": "string", "enum": ["freeware", "shareware", "commercial", "mit", "other"] }, "languages": { "anyOf": [{ "type": "array", "items": { "type": "string" }, "uniqueItems": true }, { "$ref": "#/definitions/KeyboardLanguageInfo" }] }, "lastModifiedDate": { "type": "string", "format": "date-time" }, "packageFilename": { "type": "string", "pattern": "\\.km[xp]$" }, "packageFileSize": { "type": "number" }, "jsFilename": { "type": "string", "pattern": "\\.js$" }, "jsFileSize": { "type": "number" }, "isRTL": { "type": "boolean" }, "encodings": { "type": "array", "items": { "type": "string", "enum": ["ansi", "unicode"] } }, "packageIncludes": { "type": "array", "items": { "type": "string", "enum": ["welcome", "documentation", "fonts", "visualKeyboard"] } }, "version": { "type": "string" }, "minKeymanVersion": { "type": "string", "pattern": "^\\d+\\.\\d$" }, "helpLink": { "type": "string", "pattern": "^https://help\\.keyman\\.com/keyboard/" }, "platformSupport": { "$ref": "#/definitions/KeyboardPlatformInfo" }, "sourcePath": { "type": "string", "pattern": "^(release|legacy|experimental)/.+/.+$" }, "related": { "type": "object", "patternProperties": { ".": { "$ref": "#/definitions/KeyboardRelatedInfo" } }, "additionalProperties": false }, "deprecated": { "type": "boolean" } }, "required": ["id", "name", "license", "languages", "lastModifiedDate", "platformSupport"] };
        var schema29 = { "type": "object", "patternProperties": { "^(windows|macos|desktopWeb|ios|android|mobileWeb|linux)$": { "type": "string", "enum": ["dictionary", "full", "basic", "none"] } }, "required": [], "additionalProperties": false };
        var formats0 = /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i;
        var formats2 = require_formats().fullFormats["date-time"];
        var pattern0 = new RegExp(".", "u");
        function validate23(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
            let vErrors = null;
            let errors = 0;
            if (errors === 0) {
                if (data && typeof data == "object" && !Array.isArray(data)) {
                    const _errs1 = errors;
                    for (const key0 in data) {
                        if (!(key0 === "font" || key0 === "oskFont" || key0 === "examples" || key0 === "displayName" || key0 === "languageName" || key0 === "scriptName" || key0 === "regionName")) {
                            validate23.errors = [{ instancePath, schemaPath: "#/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key0 }, message: "must NOT have additional properties" }];
                            return false;
                            break;
                        }
                    }
                    if (_errs1 === errors) {
                        if (data.font !== void 0) {
                            let data0 = data.font;
                            const _errs2 = errors;
                            const _errs3 = errors;
                            if (errors === _errs3) {
                                if (data0 && typeof data0 == "object" && !Array.isArray(data0)) {
                                    let missing0;
                                    if (data0.family === void 0 && (missing0 = "family") || data0.source === void 0 && (missing0 = "source")) {
                                        validate23.errors = [{ instancePath: instancePath + "/font", schemaPath: "#/definitions/KeyboardFontInfo/required", keyword: "required", params: { missingProperty: missing0 }, message: "must have required property '" + missing0 + "'" }];
                                        return false;
                                    }
                                    else {
                                        const _errs5 = errors;
                                        for (const key1 in data0) {
                                            if (!(key1 === "family" || key1 === "source")) {
                                                validate23.errors = [{ instancePath: instancePath + "/font", schemaPath: "#/definitions/KeyboardFontInfo/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key1 }, message: "must NOT have additional properties" }];
                                                return false;
                                                break;
                                            }
                                        }
                                        if (_errs5 === errors) {
                                            if (data0.family !== void 0) {
                                                const _errs6 = errors;
                                                if (typeof data0.family !== "string") {
                                                    validate23.errors = [{ instancePath: instancePath + "/font/family", schemaPath: "#/definitions/KeyboardFontInfo/properties/family/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                    return false;
                                                }
                                                var valid2 = _errs6 === errors;
                                            }
                                            else {
                                                var valid2 = true;
                                            }
                                            if (valid2) {
                                                if (data0.source !== void 0) {
                                                    let data2 = data0.source;
                                                    const _errs8 = errors;
                                                    if (errors === _errs8) {
                                                        if (Array.isArray(data2)) {
                                                            var valid3 = true;
                                                            const len0 = data2.length;
                                                            for (let i0 = 0; i0 < len0; i0++) {
                                                                const _errs10 = errors;
                                                                if (typeof data2[i0] !== "string") {
                                                                    validate23.errors = [{ instancePath: instancePath + "/font/source/" + i0, schemaPath: "#/definitions/KeyboardFontInfo/properties/source/items/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                    return false;
                                                                }
                                                                var valid3 = _errs10 === errors;
                                                                if (!valid3) {
                                                                    break;
                                                                }
                                                            }
                                                        }
                                                        else {
                                                            validate23.errors = [{ instancePath: instancePath + "/font/source", schemaPath: "#/definitions/KeyboardFontInfo/properties/source/type", keyword: "type", params: { type: "array" }, message: "must be array" }];
                                                            return false;
                                                        }
                                                    }
                                                    var valid2 = _errs8 === errors;
                                                }
                                                else {
                                                    var valid2 = true;
                                                }
                                            }
                                        }
                                    }
                                }
                                else {
                                    validate23.errors = [{ instancePath: instancePath + "/font", schemaPath: "#/definitions/KeyboardFontInfo/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                                    return false;
                                }
                            }
                            var valid0 = _errs2 === errors;
                        }
                        else {
                            var valid0 = true;
                        }
                        if (valid0) {
                            if (data.oskFont !== void 0) {
                                let data4 = data.oskFont;
                                const _errs12 = errors;
                                const _errs13 = errors;
                                if (errors === _errs13) {
                                    if (data4 && typeof data4 == "object" && !Array.isArray(data4)) {
                                        let missing1;
                                        if (data4.family === void 0 && (missing1 = "family") || data4.source === void 0 && (missing1 = "source")) {
                                            validate23.errors = [{ instancePath: instancePath + "/oskFont", schemaPath: "#/definitions/KeyboardFontInfo/required", keyword: "required", params: { missingProperty: missing1 }, message: "must have required property '" + missing1 + "'" }];
                                            return false;
                                        }
                                        else {
                                            const _errs15 = errors;
                                            for (const key2 in data4) {
                                                if (!(key2 === "family" || key2 === "source")) {
                                                    validate23.errors = [{ instancePath: instancePath + "/oskFont", schemaPath: "#/definitions/KeyboardFontInfo/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key2 }, message: "must NOT have additional properties" }];
                                                    return false;
                                                    break;
                                                }
                                            }
                                            if (_errs15 === errors) {
                                                if (data4.family !== void 0) {
                                                    const _errs16 = errors;
                                                    if (typeof data4.family !== "string") {
                                                        validate23.errors = [{ instancePath: instancePath + "/oskFont/family", schemaPath: "#/definitions/KeyboardFontInfo/properties/family/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                        return false;
                                                    }
                                                    var valid5 = _errs16 === errors;
                                                }
                                                else {
                                                    var valid5 = true;
                                                }
                                                if (valid5) {
                                                    if (data4.source !== void 0) {
                                                        let data6 = data4.source;
                                                        const _errs18 = errors;
                                                        if (errors === _errs18) {
                                                            if (Array.isArray(data6)) {
                                                                var valid6 = true;
                                                                const len1 = data6.length;
                                                                for (let i1 = 0; i1 < len1; i1++) {
                                                                    const _errs20 = errors;
                                                                    if (typeof data6[i1] !== "string") {
                                                                        validate23.errors = [{ instancePath: instancePath + "/oskFont/source/" + i1, schemaPath: "#/definitions/KeyboardFontInfo/properties/source/items/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                        return false;
                                                                    }
                                                                    var valid6 = _errs20 === errors;
                                                                    if (!valid6) {
                                                                        break;
                                                                    }
                                                                }
                                                            }
                                                            else {
                                                                validate23.errors = [{ instancePath: instancePath + "/oskFont/source", schemaPath: "#/definitions/KeyboardFontInfo/properties/source/type", keyword: "type", params: { type: "array" }, message: "must be array" }];
                                                                return false;
                                                            }
                                                        }
                                                        var valid5 = _errs18 === errors;
                                                    }
                                                    else {
                                                        var valid5 = true;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else {
                                        validate23.errors = [{ instancePath: instancePath + "/oskFont", schemaPath: "#/definitions/KeyboardFontInfo/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                                        return false;
                                    }
                                }
                                var valid0 = _errs12 === errors;
                            }
                            else {
                                var valid0 = true;
                            }
                            if (valid0) {
                                if (data.examples !== void 0) {
                                    let data8 = data.examples;
                                    const _errs22 = errors;
                                    if (errors === _errs22) {
                                        if (Array.isArray(data8)) {
                                            var valid7 = true;
                                            const len2 = data8.length;
                                            for (let i2 = 0; i2 < len2; i2++) {
                                                let data9 = data8[i2];
                                                const _errs24 = errors;
                                                const _errs25 = errors;
                                                if (errors === _errs25) {
                                                    if (data9 && typeof data9 == "object" && !Array.isArray(data9)) {
                                                        let missing2;
                                                        if (data9.keys === void 0 && (missing2 = "keys") || data9.text === void 0 && (missing2 = "text")) {
                                                            validate23.errors = [{ instancePath: instancePath + "/examples/" + i2, schemaPath: "#/definitions/KeyboardExampleInfo/required", keyword: "required", params: { missingProperty: missing2 }, message: "must have required property '" + missing2 + "'" }];
                                                            return false;
                                                        }
                                                        else {
                                                            const _errs27 = errors;
                                                            for (const key3 in data9) {
                                                                if (!(key3 === "keys" || key3 === "text" || key3 === "note")) {
                                                                    validate23.errors = [{ instancePath: instancePath + "/examples/" + i2, schemaPath: "#/definitions/KeyboardExampleInfo/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key3 }, message: "must NOT have additional properties" }];
                                                                    return false;
                                                                    break;
                                                                }
                                                            }
                                                            if (_errs27 === errors) {
                                                                if (data9.keys !== void 0) {
                                                                    const _errs28 = errors;
                                                                    if (typeof data9.keys !== "string") {
                                                                        validate23.errors = [{ instancePath: instancePath + "/examples/" + i2 + "/keys", schemaPath: "#/definitions/KeyboardExampleInfo/properties/keys/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                        return false;
                                                                    }
                                                                    var valid9 = _errs28 === errors;
                                                                }
                                                                else {
                                                                    var valid9 = true;
                                                                }
                                                                if (valid9) {
                                                                    if (data9.text !== void 0) {
                                                                        const _errs30 = errors;
                                                                        if (typeof data9.text !== "string") {
                                                                            validate23.errors = [{ instancePath: instancePath + "/examples/" + i2 + "/text", schemaPath: "#/definitions/KeyboardExampleInfo/properties/text/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                            return false;
                                                                        }
                                                                        var valid9 = _errs30 === errors;
                                                                    }
                                                                    else {
                                                                        var valid9 = true;
                                                                    }
                                                                    if (valid9) {
                                                                        if (data9.note !== void 0) {
                                                                            const _errs32 = errors;
                                                                            if (typeof data9.note !== "string") {
                                                                                validate23.errors = [{ instancePath: instancePath + "/examples/" + i2 + "/note", schemaPath: "#/definitions/KeyboardExampleInfo/properties/note/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                return false;
                                                                            }
                                                                            var valid9 = _errs32 === errors;
                                                                        }
                                                                        else {
                                                                            var valid9 = true;
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    else {
                                                        validate23.errors = [{ instancePath: instancePath + "/examples/" + i2, schemaPath: "#/definitions/KeyboardExampleInfo/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                                                        return false;
                                                    }
                                                }
                                                var valid7 = _errs24 === errors;
                                                if (!valid7) {
                                                    break;
                                                }
                                            }
                                        }
                                        else {
                                            validate23.errors = [{ instancePath: instancePath + "/examples", schemaPath: "#/properties/examples/type", keyword: "type", params: { type: "array" }, message: "must be array" }];
                                            return false;
                                        }
                                    }
                                    var valid0 = _errs22 === errors;
                                }
                                else {
                                    var valid0 = true;
                                }
                                if (valid0) {
                                    if (data.displayName !== void 0) {
                                        const _errs34 = errors;
                                        if (typeof data.displayName !== "string") {
                                            validate23.errors = [{ instancePath: instancePath + "/displayName", schemaPath: "#/properties/displayName/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                            return false;
                                        }
                                        var valid0 = _errs34 === errors;
                                    }
                                    else {
                                        var valid0 = true;
                                    }
                                    if (valid0) {
                                        if (data.languageName !== void 0) {
                                            const _errs36 = errors;
                                            if (typeof data.languageName !== "string") {
                                                validate23.errors = [{ instancePath: instancePath + "/languageName", schemaPath: "#/properties/languageName/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                return false;
                                            }
                                            var valid0 = _errs36 === errors;
                                        }
                                        else {
                                            var valid0 = true;
                                        }
                                        if (valid0) {
                                            if (data.scriptName !== void 0) {
                                                const _errs38 = errors;
                                                if (typeof data.scriptName !== "string") {
                                                    validate23.errors = [{ instancePath: instancePath + "/scriptName", schemaPath: "#/properties/scriptName/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                    return false;
                                                }
                                                var valid0 = _errs38 === errors;
                                            }
                                            else {
                                                var valid0 = true;
                                            }
                                            if (valid0) {
                                                if (data.regionName !== void 0) {
                                                    const _errs40 = errors;
                                                    if (typeof data.regionName !== "string") {
                                                        validate23.errors = [{ instancePath: instancePath + "/regionName", schemaPath: "#/properties/regionName/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                        return false;
                                                    }
                                                    var valid0 = _errs40 === errors;
                                                }
                                                else {
                                                    var valid0 = true;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else {
                    validate23.errors = [{ instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                    return false;
                }
            }
            validate23.errors = vErrors;
            return errors === 0;
        }
        function validate22(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
            let vErrors = null;
            let errors = 0;
            if (errors === 0) {
                if (data && typeof data == "object" && !Array.isArray(data)) {
                    const _errs1 = errors;
                    for (const key0 in data) {
                        if (!pattern0.test(key0)) {
                            validate22.errors = [{ instancePath, schemaPath: "#/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key0 }, message: "must NOT have additional properties" }];
                            return false;
                            break;
                        }
                    }
                    if (_errs1 === errors) {
                        var valid0 = true;
                        for (const key1 in data) {
                            if (pattern0.test(key1)) {
                                const _errs2 = errors;
                                if (!validate23(data[key1], { instancePath: instancePath + "/" + key1.replace(/~/g, "~0").replace(/\//g, "~1"), parentData: data, parentDataProperty: key1, rootData })) {
                                    vErrors = vErrors === null ? validate23.errors : vErrors.concat(validate23.errors);
                                    errors = vErrors.length;
                                }
                                var valid0 = _errs2 === errors;
                                if (!valid0) {
                                    break;
                                }
                            }
                        }
                    }
                }
                else {
                    validate22.errors = [{ instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                    return false;
                }
            }
            validate22.errors = vErrors;
            return errors === 0;
        }
        var pattern2 = new RegExp("\\.km[xp]$", "u");
        var pattern3 = new RegExp("\\.js$", "u");
        var pattern4 = new RegExp("^\\d+\\.\\d$", "u");
        var pattern5 = new RegExp("^https://help\\.keyman\\.com/keyboard/", "u");
        var pattern6 = new RegExp("^(windows|macos|desktopWeb|ios|android|mobileWeb|linux)$", "u");
        var pattern8 = new RegExp("^(release|legacy|experimental)/.+/.+$", "u");
        function validate21(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
            let vErrors = null;
            let errors = 0;
            if (errors === 0) {
                if (data && typeof data == "object" && !Array.isArray(data)) {
                    let missing0;
                    if (data.id === void 0 && (missing0 = "id") || data.name === void 0 && (missing0 = "name") || data.license === void 0 && (missing0 = "license") || data.languages === void 0 && (missing0 = "languages") || data.lastModifiedDate === void 0 && (missing0 = "lastModifiedDate") || data.platformSupport === void 0 && (missing0 = "platformSupport")) {
                        validate21.errors = [{ instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: missing0 }, message: "must have required property '" + missing0 + "'" }];
                        return false;
                    }
                    else {
                        if (data.id !== void 0) {
                            const _errs1 = errors;
                            if (typeof data.id !== "string") {
                                validate21.errors = [{ instancePath: instancePath + "/id", schemaPath: "#/properties/id/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                return false;
                            }
                            var valid0 = _errs1 === errors;
                        }
                        else {
                            var valid0 = true;
                        }
                        if (valid0) {
                            if (data.name !== void 0) {
                                const _errs3 = errors;
                                if (typeof data.name !== "string") {
                                    validate21.errors = [{ instancePath: instancePath + "/name", schemaPath: "#/properties/name/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                    return false;
                                }
                                var valid0 = _errs3 === errors;
                            }
                            else {
                                var valid0 = true;
                            }
                            if (valid0) {
                                if (data.authorName !== void 0) {
                                    const _errs5 = errors;
                                    if (typeof data.authorName !== "string") {
                                        validate21.errors = [{ instancePath: instancePath + "/authorName", schemaPath: "#/properties/authorName/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                        return false;
                                    }
                                    var valid0 = _errs5 === errors;
                                }
                                else {
                                    var valid0 = true;
                                }
                                if (valid0) {
                                    if (data.authorEmail !== void 0) {
                                        let data3 = data.authorEmail;
                                        const _errs7 = errors;
                                        if (errors === _errs7) {
                                            if (errors === _errs7) {
                                                if (typeof data3 === "string") {
                                                    if (!formats0.test(data3)) {
                                                        validate21.errors = [{ instancePath: instancePath + "/authorEmail", schemaPath: "#/properties/authorEmail/format", keyword: "format", params: { format: "email" }, message: 'must match format "email"' }];
                                                        return false;
                                                    }
                                                }
                                                else {
                                                    validate21.errors = [{ instancePath: instancePath + "/authorEmail", schemaPath: "#/properties/authorEmail/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                    return false;
                                                }
                                            }
                                        }
                                        var valid0 = _errs7 === errors;
                                    }
                                    else {
                                        var valid0 = true;
                                    }
                                    if (valid0) {
                                        if (data.description !== void 0) {
                                            const _errs9 = errors;
                                            if (typeof data.description !== "string") {
                                                validate21.errors = [{ instancePath: instancePath + "/description", schemaPath: "#/properties/description/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                return false;
                                            }
                                            var valid0 = _errs9 === errors;
                                        }
                                        else {
                                            var valid0 = true;
                                        }
                                        if (valid0) {
                                            if (data.license !== void 0) {
                                                let data5 = data.license;
                                                const _errs11 = errors;
                                                if (typeof data5 !== "string") {
                                                    validate21.errors = [{ instancePath: instancePath + "/license", schemaPath: "#/properties/license/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                    return false;
                                                }
                                                if (!(data5 === "freeware" || data5 === "shareware" || data5 === "commercial" || data5 === "mit" || data5 === "other")) {
                                                    validate21.errors = [{ instancePath: instancePath + "/license", schemaPath: "#/properties/license/enum", keyword: "enum", params: { allowedValues: schema23.properties.license.enum }, message: "must be equal to one of the allowed values" }];
                                                    return false;
                                                }
                                                var valid0 = _errs11 === errors;
                                            }
                                            else {
                                                var valid0 = true;
                                            }
                                            if (valid0) {
                                                if (data.languages !== void 0) {
                                                    let data6 = data.languages;
                                                    const _errs13 = errors;
                                                    const _errs14 = errors;
                                                    let valid1 = false;
                                                    const _errs15 = errors;
                                                    if (errors === _errs15) {
                                                        if (Array.isArray(data6)) {
                                                            var valid2 = true;
                                                            const len0 = data6.length;
                                                            for (let i0 = 0; i0 < len0; i0++) {
                                                                const _errs17 = errors;
                                                                if (typeof data6[i0] !== "string") {
                                                                    const err0 = { instancePath: instancePath + "/languages/" + i0, schemaPath: "#/properties/languages/anyOf/0/items/type", keyword: "type", params: { type: "string" }, message: "must be string" };
                                                                    if (vErrors === null) {
                                                                        vErrors = [err0];
                                                                    }
                                                                    else {
                                                                        vErrors.push(err0);
                                                                    }
                                                                    errors++;
                                                                }
                                                                var valid2 = _errs17 === errors;
                                                                if (!valid2) {
                                                                    break;
                                                                }
                                                            }
                                                            if (valid2) {
                                                                let i1 = data6.length;
                                                                let j0;
                                                                if (i1 > 1) {
                                                                    const indices0 = {};
                                                                    for (; i1--;) {
                                                                        let item0 = data6[i1];
                                                                        if (typeof item0 !== "string") {
                                                                            continue;
                                                                        }
                                                                        if (typeof indices0[item0] == "number") {
                                                                            j0 = indices0[item0];
                                                                            const err1 = { instancePath: instancePath + "/languages", schemaPath: "#/properties/languages/anyOf/0/uniqueItems", keyword: "uniqueItems", params: { i: i1, j: j0 }, message: "must NOT have duplicate items (items ## " + j0 + " and " + i1 + " are identical)" };
                                                                            if (vErrors === null) {
                                                                                vErrors = [err1];
                                                                            }
                                                                            else {
                                                                                vErrors.push(err1);
                                                                            }
                                                                            errors++;
                                                                            break;
                                                                        }
                                                                        indices0[item0] = i1;
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        else {
                                                            const err2 = { instancePath: instancePath + "/languages", schemaPath: "#/properties/languages/anyOf/0/type", keyword: "type", params: { type: "array" }, message: "must be array" };
                                                            if (vErrors === null) {
                                                                vErrors = [err2];
                                                            }
                                                            else {
                                                                vErrors.push(err2);
                                                            }
                                                            errors++;
                                                        }
                                                    }
                                                    var _valid0 = _errs15 === errors;
                                                    valid1 = valid1 || _valid0;
                                                    if (!valid1) {
                                                        const _errs19 = errors;
                                                        if (!validate22(data6, { instancePath: instancePath + "/languages", parentData: data, parentDataProperty: "languages", rootData })) {
                                                            vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);
                                                            errors = vErrors.length;
                                                        }
                                                        var _valid0 = _errs19 === errors;
                                                        valid1 = valid1 || _valid0;
                                                    }
                                                    if (!valid1) {
                                                        const err3 = { instancePath: instancePath + "/languages", schemaPath: "#/properties/languages/anyOf", keyword: "anyOf", params: {}, message: "must match a schema in anyOf" };
                                                        if (vErrors === null) {
                                                            vErrors = [err3];
                                                        }
                                                        else {
                                                            vErrors.push(err3);
                                                        }
                                                        errors++;
                                                        validate21.errors = vErrors;
                                                        return false;
                                                    }
                                                    else {
                                                        errors = _errs14;
                                                        if (vErrors !== null) {
                                                            if (_errs14) {
                                                                vErrors.length = _errs14;
                                                            }
                                                            else {
                                                                vErrors = null;
                                                            }
                                                        }
                                                    }
                                                    var valid0 = _errs13 === errors;
                                                }
                                                else {
                                                    var valid0 = true;
                                                }
                                                if (valid0) {
                                                    if (data.lastModifiedDate !== void 0) {
                                                        let data8 = data.lastModifiedDate;
                                                        const _errs20 = errors;
                                                        if (errors === _errs20) {
                                                            if (errors === _errs20) {
                                                                if (typeof data8 === "string") {
                                                                    if (!formats2.validate(data8)) {
                                                                        validate21.errors = [{ instancePath: instancePath + "/lastModifiedDate", schemaPath: "#/properties/lastModifiedDate/format", keyword: "format", params: { format: "date-time" }, message: 'must match format "date-time"' }];
                                                                        return false;
                                                                    }
                                                                }
                                                                else {
                                                                    validate21.errors = [{ instancePath: instancePath + "/lastModifiedDate", schemaPath: "#/properties/lastModifiedDate/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                    return false;
                                                                }
                                                            }
                                                        }
                                                        var valid0 = _errs20 === errors;
                                                    }
                                                    else {
                                                        var valid0 = true;
                                                    }
                                                    if (valid0) {
                                                        if (data.packageFilename !== void 0) {
                                                            let data9 = data.packageFilename;
                                                            const _errs22 = errors;
                                                            if (errors === _errs22) {
                                                                if (typeof data9 === "string") {
                                                                    if (!pattern2.test(data9)) {
                                                                        validate21.errors = [{ instancePath: instancePath + "/packageFilename", schemaPath: "#/properties/packageFilename/pattern", keyword: "pattern", params: { pattern: "\\.km[xp]$" }, message: 'must match pattern "\\.km[xp]$"' }];
                                                                        return false;
                                                                    }
                                                                }
                                                                else {
                                                                    validate21.errors = [{ instancePath: instancePath + "/packageFilename", schemaPath: "#/properties/packageFilename/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                    return false;
                                                                }
                                                            }
                                                            var valid0 = _errs22 === errors;
                                                        }
                                                        else {
                                                            var valid0 = true;
                                                        }
                                                        if (valid0) {
                                                            if (data.packageFileSize !== void 0) {
                                                                let data10 = data.packageFileSize;
                                                                const _errs24 = errors;
                                                                if (!(typeof data10 == "number" && isFinite(data10))) {
                                                                    validate21.errors = [{ instancePath: instancePath + "/packageFileSize", schemaPath: "#/properties/packageFileSize/type", keyword: "type", params: { type: "number" }, message: "must be number" }];
                                                                    return false;
                                                                }
                                                                var valid0 = _errs24 === errors;
                                                            }
                                                            else {
                                                                var valid0 = true;
                                                            }
                                                            if (valid0) {
                                                                if (data.jsFilename !== void 0) {
                                                                    let data11 = data.jsFilename;
                                                                    const _errs26 = errors;
                                                                    if (errors === _errs26) {
                                                                        if (typeof data11 === "string") {
                                                                            if (!pattern3.test(data11)) {
                                                                                validate21.errors = [{ instancePath: instancePath + "/jsFilename", schemaPath: "#/properties/jsFilename/pattern", keyword: "pattern", params: { pattern: "\\.js$" }, message: 'must match pattern "\\.js$"' }];
                                                                                return false;
                                                                            }
                                                                        }
                                                                        else {
                                                                            validate21.errors = [{ instancePath: instancePath + "/jsFilename", schemaPath: "#/properties/jsFilename/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                            return false;
                                                                        }
                                                                    }
                                                                    var valid0 = _errs26 === errors;
                                                                }
                                                                else {
                                                                    var valid0 = true;
                                                                }
                                                                if (valid0) {
                                                                    if (data.jsFileSize !== void 0) {
                                                                        let data12 = data.jsFileSize;
                                                                        const _errs28 = errors;
                                                                        if (!(typeof data12 == "number" && isFinite(data12))) {
                                                                            validate21.errors = [{ instancePath: instancePath + "/jsFileSize", schemaPath: "#/properties/jsFileSize/type", keyword: "type", params: { type: "number" }, message: "must be number" }];
                                                                            return false;
                                                                        }
                                                                        var valid0 = _errs28 === errors;
                                                                    }
                                                                    else {
                                                                        var valid0 = true;
                                                                    }
                                                                    if (valid0) {
                                                                        if (data.isRTL !== void 0) {
                                                                            const _errs30 = errors;
                                                                            if (typeof data.isRTL !== "boolean") {
                                                                                validate21.errors = [{ instancePath: instancePath + "/isRTL", schemaPath: "#/properties/isRTL/type", keyword: "type", params: { type: "boolean" }, message: "must be boolean" }];
                                                                                return false;
                                                                            }
                                                                            var valid0 = _errs30 === errors;
                                                                        }
                                                                        else {
                                                                            var valid0 = true;
                                                                        }
                                                                        if (valid0) {
                                                                            if (data.encodings !== void 0) {
                                                                                let data14 = data.encodings;
                                                                                const _errs32 = errors;
                                                                                if (errors === _errs32) {
                                                                                    if (Array.isArray(data14)) {
                                                                                        var valid4 = true;
                                                                                        const len1 = data14.length;
                                                                                        for (let i2 = 0; i2 < len1; i2++) {
                                                                                            let data15 = data14[i2];
                                                                                            const _errs34 = errors;
                                                                                            if (typeof data15 !== "string") {
                                                                                                validate21.errors = [{ instancePath: instancePath + "/encodings/" + i2, schemaPath: "#/properties/encodings/items/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                                return false;
                                                                                            }
                                                                                            if (!(data15 === "ansi" || data15 === "unicode")) {
                                                                                                validate21.errors = [{ instancePath: instancePath + "/encodings/" + i2, schemaPath: "#/properties/encodings/items/enum", keyword: "enum", params: { allowedValues: schema23.properties.encodings.items.enum }, message: "must be equal to one of the allowed values" }];
                                                                                                return false;
                                                                                            }
                                                                                            var valid4 = _errs34 === errors;
                                                                                            if (!valid4) {
                                                                                                break;
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                    else {
                                                                                        validate21.errors = [{ instancePath: instancePath + "/encodings", schemaPath: "#/properties/encodings/type", keyword: "type", params: { type: "array" }, message: "must be array" }];
                                                                                        return false;
                                                                                    }
                                                                                }
                                                                                var valid0 = _errs32 === errors;
                                                                            }
                                                                            else {
                                                                                var valid0 = true;
                                                                            }
                                                                            if (valid0) {
                                                                                if (data.packageIncludes !== void 0) {
                                                                                    let data16 = data.packageIncludes;
                                                                                    const _errs36 = errors;
                                                                                    if (errors === _errs36) {
                                                                                        if (Array.isArray(data16)) {
                                                                                            var valid5 = true;
                                                                                            const len2 = data16.length;
                                                                                            for (let i3 = 0; i3 < len2; i3++) {
                                                                                                let data17 = data16[i3];
                                                                                                const _errs38 = errors;
                                                                                                if (typeof data17 !== "string") {
                                                                                                    validate21.errors = [{ instancePath: instancePath + "/packageIncludes/" + i3, schemaPath: "#/properties/packageIncludes/items/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                                    return false;
                                                                                                }
                                                                                                if (!(data17 === "welcome" || data17 === "documentation" || data17 === "fonts" || data17 === "visualKeyboard")) {
                                                                                                    validate21.errors = [{ instancePath: instancePath + "/packageIncludes/" + i3, schemaPath: "#/properties/packageIncludes/items/enum", keyword: "enum", params: { allowedValues: schema23.properties.packageIncludes.items.enum }, message: "must be equal to one of the allowed values" }];
                                                                                                    return false;
                                                                                                }
                                                                                                var valid5 = _errs38 === errors;
                                                                                                if (!valid5) {
                                                                                                    break;
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                        else {
                                                                                            validate21.errors = [{ instancePath: instancePath + "/packageIncludes", schemaPath: "#/properties/packageIncludes/type", keyword: "type", params: { type: "array" }, message: "must be array" }];
                                                                                            return false;
                                                                                        }
                                                                                    }
                                                                                    var valid0 = _errs36 === errors;
                                                                                }
                                                                                else {
                                                                                    var valid0 = true;
                                                                                }
                                                                                if (valid0) {
                                                                                    if (data.version !== void 0) {
                                                                                        const _errs40 = errors;
                                                                                        if (typeof data.version !== "string") {
                                                                                            validate21.errors = [{ instancePath: instancePath + "/version", schemaPath: "#/properties/version/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                            return false;
                                                                                        }
                                                                                        var valid0 = _errs40 === errors;
                                                                                    }
                                                                                    else {
                                                                                        var valid0 = true;
                                                                                    }
                                                                                    if (valid0) {
                                                                                        if (data.minKeymanVersion !== void 0) {
                                                                                            let data19 = data.minKeymanVersion;
                                                                                            const _errs42 = errors;
                                                                                            if (errors === _errs42) {
                                                                                                if (typeof data19 === "string") {
                                                                                                    if (!pattern4.test(data19)) {
                                                                                                        validate21.errors = [{ instancePath: instancePath + "/minKeymanVersion", schemaPath: "#/properties/minKeymanVersion/pattern", keyword: "pattern", params: { pattern: "^\\d+\\.\\d$" }, message: 'must match pattern "^\\d+\\.\\d$"' }];
                                                                                                        return false;
                                                                                                    }
                                                                                                }
                                                                                                else {
                                                                                                    validate21.errors = [{ instancePath: instancePath + "/minKeymanVersion", schemaPath: "#/properties/minKeymanVersion/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                                    return false;
                                                                                                }
                                                                                            }
                                                                                            var valid0 = _errs42 === errors;
                                                                                        }
                                                                                        else {
                                                                                            var valid0 = true;
                                                                                        }
                                                                                        if (valid0) {
                                                                                            if (data.helpLink !== void 0) {
                                                                                                let data20 = data.helpLink;
                                                                                                const _errs44 = errors;
                                                                                                if (errors === _errs44) {
                                                                                                    if (typeof data20 === "string") {
                                                                                                        if (!pattern5.test(data20)) {
                                                                                                            validate21.errors = [{ instancePath: instancePath + "/helpLink", schemaPath: "#/properties/helpLink/pattern", keyword: "pattern", params: { pattern: "^https://help\\.keyman\\.com/keyboard/" }, message: 'must match pattern "^https://help\\.keyman\\.com/keyboard/"' }];
                                                                                                            return false;
                                                                                                        }
                                                                                                    }
                                                                                                    else {
                                                                                                        validate21.errors = [{ instancePath: instancePath + "/helpLink", schemaPath: "#/properties/helpLink/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                                        return false;
                                                                                                    }
                                                                                                }
                                                                                                var valid0 = _errs44 === errors;
                                                                                            }
                                                                                            else {
                                                                                                var valid0 = true;
                                                                                            }
                                                                                            if (valid0) {
                                                                                                if (data.platformSupport !== void 0) {
                                                                                                    let data21 = data.platformSupport;
                                                                                                    const _errs46 = errors;
                                                                                                    const _errs47 = errors;
                                                                                                    if (errors === _errs47) {
                                                                                                        if (data21 && typeof data21 == "object" && !Array.isArray(data21)) {
                                                                                                            const _errs49 = errors;
                                                                                                            for (const key0 in data21) {
                                                                                                                if (!pattern6.test(key0)) {
                                                                                                                    validate21.errors = [{ instancePath: instancePath + "/platformSupport", schemaPath: "#/definitions/KeyboardPlatformInfo/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key0 }, message: "must NOT have additional properties" }];
                                                                                                                    return false;
                                                                                                                    break;
                                                                                                                }
                                                                                                            }
                                                                                                            if (_errs49 === errors) {
                                                                                                                var valid7 = true;
                                                                                                                for (const key1 in data21) {
                                                                                                                    if (pattern6.test(key1)) {
                                                                                                                        let data22 = data21[key1];
                                                                                                                        const _errs50 = errors;
                                                                                                                        if (typeof data22 !== "string") {
                                                                                                                            validate21.errors = [{ instancePath: instancePath + "/platformSupport/" + key1.replace(/~/g, "~0").replace(/\//g, "~1"), schemaPath: "#/definitions/KeyboardPlatformInfo/patternProperties/%5E(windows%7Cmacos%7CdesktopWeb%7Cios%7Candroid%7CmobileWeb%7Clinux)%24/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                                                            return false;
                                                                                                                        }
                                                                                                                        if (!(data22 === "dictionary" || data22 === "full" || data22 === "basic" || data22 === "none")) {
                                                                                                                            validate21.errors = [{ instancePath: instancePath + "/platformSupport/" + key1.replace(/~/g, "~0").replace(/\//g, "~1"), schemaPath: "#/definitions/KeyboardPlatformInfo/patternProperties/%5E(windows%7Cmacos%7CdesktopWeb%7Cios%7Candroid%7CmobileWeb%7Clinux)%24/enum", keyword: "enum", params: { allowedValues: schema29.patternProperties["^(windows|macos|desktopWeb|ios|android|mobileWeb|linux)$"].enum }, message: "must be equal to one of the allowed values" }];
                                                                                                                            return false;
                                                                                                                        }
                                                                                                                        var valid7 = _errs50 === errors;
                                                                                                                        if (!valid7) {
                                                                                                                            break;
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                        else {
                                                                                                            validate21.errors = [{ instancePath: instancePath + "/platformSupport", schemaPath: "#/definitions/KeyboardPlatformInfo/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                                                                                                            return false;
                                                                                                        }
                                                                                                    }
                                                                                                    var valid0 = _errs46 === errors;
                                                                                                }
                                                                                                else {
                                                                                                    var valid0 = true;
                                                                                                }
                                                                                                if (valid0) {
                                                                                                    if (data.sourcePath !== void 0) {
                                                                                                        let data23 = data.sourcePath;
                                                                                                        const _errs52 = errors;
                                                                                                        if (errors === _errs52) {
                                                                                                            if (typeof data23 === "string") {
                                                                                                                if (!pattern8.test(data23)) {
                                                                                                                    validate21.errors = [{ instancePath: instancePath + "/sourcePath", schemaPath: "#/properties/sourcePath/pattern", keyword: "pattern", params: { pattern: "^(release|legacy|experimental)/.+/.+$" }, message: 'must match pattern "^(release|legacy|experimental)/.+/.+$"' }];
                                                                                                                    return false;
                                                                                                                }
                                                                                                            }
                                                                                                            else {
                                                                                                                validate21.errors = [{ instancePath: instancePath + "/sourcePath", schemaPath: "#/properties/sourcePath/type", keyword: "type", params: { type: "string" }, message: "must be string" }];
                                                                                                                return false;
                                                                                                            }
                                                                                                        }
                                                                                                        var valid0 = _errs52 === errors;
                                                                                                    }
                                                                                                    else {
                                                                                                        var valid0 = true;
                                                                                                    }
                                                                                                    if (valid0) {
                                                                                                        if (data.related !== void 0) {
                                                                                                            let data24 = data.related;
                                                                                                            const _errs54 = errors;
                                                                                                            if (errors === _errs54) {
                                                                                                                if (data24 && typeof data24 == "object" && !Array.isArray(data24)) {
                                                                                                                    const _errs56 = errors;
                                                                                                                    for (const key2 in data24) {
                                                                                                                        if (!pattern0.test(key2)) {
                                                                                                                            validate21.errors = [{ instancePath: instancePath + "/related", schemaPath: "#/properties/related/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key2 }, message: "must NOT have additional properties" }];
                                                                                                                            return false;
                                                                                                                            break;
                                                                                                                        }
                                                                                                                    }
                                                                                                                    if (_errs56 === errors) {
                                                                                                                        var valid8 = true;
                                                                                                                        for (const key3 in data24) {
                                                                                                                            if (pattern0.test(key3)) {
                                                                                                                                let data25 = data24[key3];
                                                                                                                                const _errs57 = errors;
                                                                                                                                const _errs58 = errors;
                                                                                                                                if (errors === _errs58) {
                                                                                                                                    if (data25 && typeof data25 == "object" && !Array.isArray(data25)) {
                                                                                                                                        const _errs60 = errors;
                                                                                                                                        for (const key4 in data25) {
                                                                                                                                            if (!(key4 === "deprecates" || key4 === "deprecatedBy")) {
                                                                                                                                                validate21.errors = [{ instancePath: instancePath + "/related/" + key3.replace(/~/g, "~0").replace(/\//g, "~1"), schemaPath: "#/definitions/KeyboardRelatedInfo/additionalProperties", keyword: "additionalProperties", params: { additionalProperty: key4 }, message: "must NOT have additional properties" }];
                                                                                                                                                return false;
                                                                                                                                                break;
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                        if (_errs60 === errors) {
                                                                                                                                            if (data25.deprecates !== void 0) {
                                                                                                                                                const _errs61 = errors;
                                                                                                                                                if (typeof data25.deprecates !== "boolean") {
                                                                                                                                                    validate21.errors = [{ instancePath: instancePath + "/related/" + key3.replace(/~/g, "~0").replace(/\//g, "~1") + "/deprecates", schemaPath: "#/definitions/KeyboardRelatedInfo/properties/deprecates/type", keyword: "type", params: { type: "boolean" }, message: "must be boolean" }];
                                                                                                                                                    return false;
                                                                                                                                                }
                                                                                                                                                var valid10 = _errs61 === errors;
                                                                                                                                            }
                                                                                                                                            else {
                                                                                                                                                var valid10 = true;
                                                                                                                                            }
                                                                                                                                            if (valid10) {
                                                                                                                                                if (data25.deprecatedBy !== void 0) {
                                                                                                                                                    const _errs63 = errors;
                                                                                                                                                    if (typeof data25.deprecatedBy !== "boolean") {
                                                                                                                                                        validate21.errors = [{ instancePath: instancePath + "/related/" + key3.replace(/~/g, "~0").replace(/\//g, "~1") + "/deprecatedBy", schemaPath: "#/definitions/KeyboardRelatedInfo/properties/deprecatedBy/type", keyword: "type", params: { type: "boolean" }, message: "must be boolean" }];
                                                                                                                                                        return false;
                                                                                                                                                    }
                                                                                                                                                    var valid10 = _errs63 === errors;
                                                                                                                                                }
                                                                                                                                                else {
                                                                                                                                                    var valid10 = true;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                    else {
                                                                                                                                        validate21.errors = [{ instancePath: instancePath + "/related/" + key3.replace(/~/g, "~0").replace(/\//g, "~1"), schemaPath: "#/definitions/KeyboardRelatedInfo/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                                                                                                                                        return false;
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                var valid8 = _errs57 === errors;
                                                                                                                                if (!valid8) {
                                                                                                                                    break;
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                                else {
                                                                                                                    validate21.errors = [{ instancePath: instancePath + "/related", schemaPath: "#/properties/related/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                                                                                                                    return false;
                                                                                                                }
                                                                                                            }
                                                                                                            var valid0 = _errs54 === errors;
                                                                                                        }
                                                                                                        else {
                                                                                                            var valid0 = true;
                                                                                                        }
                                                                                                        if (valid0) {
                                                                                                            if (data.deprecated !== void 0) {
                                                                                                                const _errs65 = errors;
                                                                                                                if (typeof data.deprecated !== "boolean") {
                                                                                                                    validate21.errors = [{ instancePath: instancePath + "/deprecated", schemaPath: "#/properties/deprecated/type", keyword: "type", params: { type: "boolean" }, message: "must be boolean" }];
                                                                                                                    return false;
                                                                                                                }
                                                                                                                var valid0 = _errs65 === errors;
                                                                                                            }
                                                                                                            else {
                                                                                                                var valid0 = true;
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else {
                    validate21.errors = [{ instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" }];
                    return false;
                }
            }
            validate21.errors = vErrors;
            return errors === 0;
        }
        function validate20(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
            let vErrors = null;
            let errors = 0;
            if (!validate21(data, { instancePath, parentData, parentDataProperty, rootData })) {
                vErrors = vErrors === null ? validate21.errors : vErrors.concat(validate21.errors);
                errors = vErrors.length;
            }
            validate20.errors = vErrors;
            return errors === 0;
        }
    }
});
export default require_keyboard_info_schema_validator();
//# sourceMappingURL=keyboard_info.schema.validator.mjs.map