declare const _default: {
    $schema: string;
    $ref: string;
    $comment: string;
    description: string;
    definitions: {
        "touch-layout": {
            type: string;
            properties: {
                tablet: {
                    $ref: string;
                };
                phone: {
                    $ref: string;
                };
                desktop: {
                    $ref: string;
                };
            };
        };
        platform: {
            type: string;
            properties: {
                font: {
                    $ref: string;
                };
                fontsize: {
                    $ref: string;
                };
                layer: {
                    $ref: string;
                };
                displayUnderlying: {
                    type: string;
                };
                defaultHint: {
                    type: string;
                    enum: string[];
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        layers: {
            type: string;
            items: {
                $ref: string;
            };
        };
        layer: {
            type: string;
            properties: {
                id: {
                    $ref: string;
                };
                row: {
                    $ref: string;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        "layer-id": {
            type: string;
            pattern: string;
        };
        rows: {
            type: string;
            items: {
                $ref: string;
            };
        };
        row: {
            type: string;
            properties: {
                id: {
                    $ref: string;
                };
                key: {
                    $ref: string;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        "row-id": {
            oneOf: ({
                type: string;
                minimum: number;
                maximum: number;
                pattern?: undefined;
            } | {
                type: string;
                pattern: string;
                minimum?: undefined;
                maximum?: undefined;
            })[];
        };
        keys: {
            type: string;
            items: {
                $ref: string;
            };
        };
        key: {
            type: string;
            properties: {
                id: {
                    $ref: string;
                };
                text: {
                    type: string;
                };
                layer: {
                    $ref: string;
                };
                nextlayer: {
                    $ref: string;
                };
                fontsize: {
                    $ref: string;
                };
                font: {
                    $ref: string;
                };
                dk: {
                    type: string;
                };
                sp: {
                    $ref: string;
                };
                pad: {
                    $ref: string;
                };
                width: {
                    $ref: string;
                };
                sk: {
                    $ref: string;
                };
                flick: {
                    $ref: string;
                };
                multitap: {
                    $ref: string;
                };
                hint: {
                    type: string;
                };
            };
            additionalProperties: boolean;
        };
        numeric: {
            oneOf: ({
                type: string;
                pattern: string;
            } | {
                type: string;
                pattern?: undefined;
            })[];
        };
        "key-id": {
            type: string;
            pattern: string;
        };
        subkeys: {
            type: string;
            items: {
                $ref: string;
            };
        };
        subkey: {
            type: string;
            properties: {
                id: {
                    $ref: string;
                };
                text: {
                    type: string;
                };
                layer: {
                    $ref: string;
                };
                nextlayer: {
                    $ref: string;
                };
                sp: {
                    $ref: string;
                };
                pad: {
                    $ref: string;
                };
                width: {
                    $ref: string;
                };
                fontsize: {
                    $ref: string;
                };
                font: {
                    $ref: string;
                };
                dk: {
                    type: string;
                };
                default: {
                    type: string;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        flick: {
            type: string;
            patternProperties: {
                "^(n|s|e|w|ne|nw|se|sw)$": {
                    $ref: string;
                };
            };
            additionalProperties: boolean;
        };
        "font-spec": {
            type: string;
        };
        "fontsize-spec": {
            type: string;
        };
    };
};
export default _default;
//# sourceMappingURL=keyman-touch-layout.spec.d.ts.map