declare const _default: {
    title: string;
    $schema: string;
    type: string;
    properties: {
        KeymanDeveloperProject: {
            properties: {
                Options: {
                    $ref: string;
                };
                Files: {
                    $ref: string;
                };
                templatepath: {
                    type: string;
                    $comment: string;
                };
                stringspath: {
                    type: string;
                    $comment: string;
                };
                state: {
                    type: string;
                    $comment: string;
                };
                Modules: {
                    oneOf: {
                        type: string;
                    }[];
                    $comment: string;
                };
                MRU: {
                    type: string;
                    $comment: string;
                };
            };
            required: any[];
            additionalProperties: boolean;
            type: string;
        };
    };
    required: string[];
    additionalProperties: boolean;
    definitions: {
        Options: {
            type: string;
            properties: {
                BuildPath: {
                    type: string;
                };
                SourcePath: {
                    type: string;
                };
                CompilerWarningsAsErrors: {
                    type: string;
                    pattern: string;
                };
                WarnDeprecatedCode: {
                    type: string;
                    pattern: string;
                };
                CheckFilenameConventions: {
                    type: string;
                    pattern: string;
                };
                ProjectType: {
                    type: string;
                    pattern: string;
                };
                Version: {
                    type: string;
                    pattern: string;
                };
            };
            required: any[];
            additionalProperties: boolean;
        };
        Files: {
            type: string;
            properties: {
                File: {
                    type: string;
                    items: {
                        $ref: string;
                    };
                };
            };
            additionalProperties: boolean;
            required: string[];
        };
        File: {
            type: string;
            properties: {
                ID: {
                    type: string;
                };
                Filename: {
                    type: string;
                };
                Filepath: {
                    type: string;
                };
                FileVersion: {
                    type: string;
                };
                FileType: {
                    type: string;
                };
                Details: {
                    $ref: string;
                };
                ParentFileID: {
                    type: string;
                };
                FullPath: {
                    type: string;
                    $comment: string;
                };
                IDEState: {
                    type: string;
                    $comment: string;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        FileDetails: {
            type: string;
            properties: {
                Name: {
                    type: string;
                };
                Copyright: {
                    type: string;
                };
                Message: {
                    type: string;
                };
                Version: {
                    type: string;
                };
                Debug: {
                    type: string;
                    $comment: string;
                };
            };
            required: any[];
            additionalProperties: boolean;
        };
    };
};
export default _default;
//# sourceMappingURL=kpj-9.0.schema.d.ts.map