declare const _default: {
    title: string;
    $schema: string;
    type: string;
    properties: {
        visualkeyboard: {
            properties: {
                header: {
                    $ref: string;
                };
                encoding: {
                    type: string;
                    items: {
                        $ref: string;
                    };
                };
            };
            required: string[];
            additionalProperties: boolean;
            type: string;
        };
    };
    required: string[];
    additionalProperties: boolean;
    definitions: {
        "kvk-header": {
            type: string;
            properties: {
                version: {
                    $ref: string;
                };
                kbdname: {
                    type: string;
                };
                flags: {
                    $ref: string;
                };
                layout: {
                    type: string;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        "kvk-header-flags": {
            type: string;
            properties: {
                key102: {
                    $ref: string;
                };
                displayunderlying: {
                    $ref: string;
                };
                usealtgr: {
                    $ref: string;
                };
                useunderlying: {
                    $ref: string;
                };
            };
            additionalProperties: boolean;
        };
        "kvk-encoding": {
            type: string;
            properties: {
                layer: {
                    type: string;
                    items: {
                        $ref: string;
                    };
                };
                $: {
                    type: string;
                    properties: {
                        name: {
                            $ref: string;
                        };
                        fontname: {
                            type: string;
                        };
                        fontsize: {
                            type: string;
                        };
                    };
                    required: string[];
                    additionalProperties: boolean;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        "kvk-layer": {
            type: string;
            properties: {
                key: {
                    type: string;
                    items: {
                        $ref: string;
                    };
                };
                $: {
                    type: string;
                    properties: {
                        shift: {
                            $ref: string;
                        };
                    };
                    required: string[];
                    additionalProperties: boolean;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        "kvk-key": {
            type: string;
            properties: {
                bitmap: {
                    type: string;
                };
                $: {
                    type: string;
                    properties: {
                        vkey: {
                            type: string;
                        };
                    };
                    required: string[];
                    additionalProperties: boolean;
                };
                _: {
                    type: string;
                };
            };
            required: string[];
            additionalProperties: boolean;
        };
        "km-empty": {
            type: string;
        };
        "kvk-encoding-name": {
            type: string;
            enum: string[];
        };
        "kvk-layer-shift": {
            type: string;
            pattern: string;
        };
        "kvk-version": {
            type: string;
            pattern: string;
            enum: string[];
        };
        "km-version": {
            type: string;
            pattern: string;
        };
    };
};
export default _default;
//# sourceMappingURL=kvks.schema.d.ts.map