declare const _default: {
    $schema: string;
    additionalProperties: boolean;
    definitions: {
        any: {
            type: string;
        };
        display: {
            additionalProperties: boolean;
            properties: {
                display: {
                    type: string;
                };
                keyId: {
                    type: string;
                };
                output: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        displayOptions: {
            additionalProperties: boolean;
            properties: {
                baseCharacter: {
                    type: string;
                };
            };
            type: string;
        };
        displays: {
            additionalProperties: boolean;
            properties: {
                display: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                displayOptions: {
                    $ref: string;
                };
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        flick: {
            additionalProperties: boolean;
            properties: {
                flickSegment: {
                    items: {
                        $ref: string;
                    };
                    minItems: number;
                    type: string;
                };
                id: {
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        flickSegment: {
            additionalProperties: boolean;
            properties: {
                directions: {
                    type: string;
                };
                keyId: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        flicks: {
            additionalProperties: boolean;
            properties: {
                flick: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        form: {
            additionalProperties: boolean;
            properties: {
                id: {
                    type: string;
                };
                scanCodes: {
                    items: {
                        $ref: string;
                    };
                    minItems: number;
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        forms: {
            additionalProperties: boolean;
            properties: {
                form: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        import: {
            additionalProperties: boolean;
            properties: {
                base: {
                    type: string;
                };
                path: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        info: {
            additionalProperties: boolean;
            properties: {
                author: {
                    type: string;
                };
                indicator: {
                    type: string;
                };
                layout: {
                    type: string;
                };
                name: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        key: {
            additionalProperties: boolean;
            properties: {
                flickId: {
                    type: string;
                };
                gap: {
                    enum: string[];
                    type: string;
                };
                id: {
                    type: string;
                };
                layerId: {
                    type: string;
                };
                longPressDefaultKeyId: {
                    type: string;
                };
                longPressKeyIds: {
                    type: string;
                };
                multiTapKeyIds: {
                    type: string;
                };
                output: {
                    type: string;
                };
                stretch: {
                    enum: string[];
                    type: string;
                };
                width: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        keys: {
            additionalProperties: boolean;
            properties: {
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                key: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        layer: {
            additionalProperties: boolean;
            properties: {
                id: {
                    type: string;
                };
                modifiers: {
                    type: string;
                };
                row: {
                    items: {
                        $ref: string;
                    };
                    minItems: number;
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        layers: {
            additionalProperties: boolean;
            properties: {
                formId: {
                    type: string;
                };
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                layer: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                minDeviceWidth: {
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        locale: {
            additionalProperties: boolean;
            properties: {
                id: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        locales: {
            additionalProperties: boolean;
            properties: {
                locale: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        reorder: {
            additionalProperties: boolean;
            properties: {
                before: {
                    type: string;
                };
                from: {
                    type: string;
                };
                order: {
                    type: string;
                };
                preBase: {
                    type: string;
                };
                tertiary: {
                    type: string;
                };
                tertiaryBase: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        row: {
            additionalProperties: boolean;
            properties: {
                keys: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        scanCodes: {
            additionalProperties: boolean;
            properties: {
                codes: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        set: {
            additionalProperties: boolean;
            properties: {
                id: {
                    type: string;
                };
                value: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        settings: {
            additionalProperties: boolean;
            properties: {
                normalization: {
                    enum: string[];
                    type: string;
                };
            };
            type: string;
        };
        special: {
            $ref: string;
        };
        stringVariable: {
            additionalProperties: boolean;
            properties: {
                id: {
                    type: string;
                };
                value: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        transform: {
            additionalProperties: boolean;
            properties: {
                from: {
                    type: string;
                };
                to: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        transformGroup: {
            additionalProperties: boolean;
            properties: {
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                reorder: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                transform: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        transforms: {
            additionalProperties: boolean;
            properties: {
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                transformGroup: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                type: {
                    enum: string[];
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        uset: {
            additionalProperties: boolean;
            properties: {
                id: {
                    type: string;
                };
                value: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        variables: {
            additionalProperties: boolean;
            properties: {
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                set: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                string: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                uset: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
            };
            type: string;
        };
        version: {
            additionalProperties: boolean;
            properties: {
                cldrVersion: {
                    enum: string[];
                    type: string;
                };
                number: {
                    type: string;
                };
            };
            type: string;
        };
    };
    properties: {
        keyboard3: {
            additionalProperties: boolean;
            properties: {
                conformsTo: {
                    enum: string[];
                    type: string;
                };
                displays: {
                    $ref: string;
                };
                flicks: {
                    $ref: string;
                };
                forms: {
                    $ref: string;
                };
                import: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                info: {
                    $ref: string;
                };
                keys: {
                    $ref: string;
                };
                layers: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                locale: {
                    type: string;
                };
                locales: {
                    $ref: string;
                };
                settings: {
                    $ref: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                transforms: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                variables: {
                    $ref: string;
                };
                version: {
                    $ref: string;
                };
                xmlns: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
    };
    required: string[];
    title: string;
    type: string;
};
export default _default;
//# sourceMappingURL=ldml-keyboard3.schema.d.ts.map