import { KMX } from '@keymanapp/common-types';
import KMXFile = KMX.KMXFile;
import GROUP = KMX.GROUP;
import KEY = KMX.KEY;
import STORE = KMX.STORE;
import BUILDER_COMP_KEYBOARD = KMX.BUILDER_COMP_KEYBOARD;
import BUILDER_COMP_KEYBOARD_KMXPLUSINFO = KMX.BUILDER_COMP_KEYBOARD_KMXPLUSINFO;
import BUILDER_COMP_STORE = KMX.BUILDER_COMP_STORE;
import BUILDER_COMP_GROUP = KMX.BUILDER_COMP_GROUP;
import BUILDER_COMP_KEY = KMX.BUILDER_COMP_KEY;
export default class KMXBuilder {
    file: KMXFile;
    base_keyboard: number;
    base_kmxplus: number;
    comp_header: BUILDER_COMP_KEYBOARD;
    comp_kmxplus: BUILDER_COMP_KEYBOARD_KMXPLUSINFO;
    comp_stores: {
        base: number;
        store: STORE;
        obj: BUILDER_COMP_STORE;
    }[];
    comp_groups: {
        base: number;
        group: GROUP;
        obj: BUILDER_COMP_GROUP;
        keys: {
            base: number;
            key: KEY;
            obj: BUILDER_COMP_KEY;
        }[];
    }[];
    comp_kmxplus_data: Uint8Array;
    writeDebug: boolean;
    constructor(file: KMXFile, writeDebug: boolean);
    calculateStringOffsetAndSize(string: string, base: number, requireString?: boolean): number[];
    private build;
    buildBitmap(): number;
    buildKMXPlus(base: number): number;
    setString(file: Uint8Array, pos: number, str: string, requireString?: boolean): void;
    compile(): Uint8Array;
}
//# sourceMappingURL=kmx-builder.d.ts.map