import { KMXPlus } from "@keymanapp/common-types";
import { BUILDER_STR_REF, BUILDER_STRS } from "./build-strs.js";
import { BUILDER_LIST } from "./build-list.js";
import { BUILDER_SECTION } from "./builder-section.js";
import KMXPlusData = KMXPlus.KMXPlusData;
import LayrEntry = KMXPlus.LayrEntry;
import LayrRow = KMXPlus.LayrRow;
/**
 * List of layers, the <layers> element
 */
interface BUILDER_LAYR_LIST {
    hardware: BUILDER_STR_REF;
    layer: number;
    count: number;
    minDeviceWidth: number;
    _layers: LayrEntry[];
}
/**
 * <layer> element
 */
interface BUILDER_LAYR_LAYER {
    id: BUILDER_STR_REF;
    _id: string;
    mod: number;
    row: number;
    _rows: LayrRow[];
    count: number;
}
/**
 * <row> element
 */
interface BUILDER_LAYR_ROW {
    key: number;
    count: number;
}
/**
 * portion of keys attribute of <row>
 */
interface BUILDER_LAYR_KEY {
    key: number;
}
/**
 * Builder for the 'keys' section
 */
export interface BUILDER_LAYR extends BUILDER_SECTION {
    listCount: number;
    layerCount: number;
    rowCount: number;
    keyCount: number;
    lists: BUILDER_LAYR_LIST[];
    layers: BUILDER_LAYR_LAYER[];
    rows: BUILDER_LAYR_ROW[];
    keys: BUILDER_LAYR_KEY[];
}
export declare function build_layr(kmxplus: KMXPlusData, sect_strs: BUILDER_STRS, sect_list: BUILDER_LIST): BUILDER_LAYR;
export {};
//# sourceMappingURL=build-layr.d.ts.map