import { KMXPlus } from "@keymanapp/common-types";
import { BUILDER_STR_REF, BUILDER_STRS } from "./build-strs.js";
import { BUILDER_SECTION } from "./builder-section.js";
import List = KMXPlus.List;
import ListItem = KMXPlus.ListItem;
/** reference from build_list_index */
export type BUILDER_LIST_REF = number;
/**
* A list entry.
*/
interface BUILDER_LIST_LIST {
    index: number;
    count: number;
    _value: ListItem;
}
interface BUILDER_LIST_INDEX {
    str: BUILDER_STR_REF;
    _value: string;
}
/**
 * Builder for the 'list' section
 */
export interface BUILDER_LIST extends BUILDER_SECTION {
    listCount: number;
    indexCount: number;
    lists: BUILDER_LIST_LIST[];
    indices: BUILDER_LIST_INDEX[];
}
export declare function build_list(source_list: List, sect_strs: BUILDER_STRS): BUILDER_LIST;
/**
 * Returns the index into the list, analagous to build_strs_index
 * @param sect_strs
 * @param value
 * @returns
 */
export declare function build_list_index(sect_list: BUILDER_LIST, value: ListItem): BUILDER_LIST_REF;
export {};
//# sourceMappingURL=build-list.d.ts.map