import { constants } from "@keymanapp/ldml-keyboard-constants";
import { KMXPlus } from "@keymanapp/common-types";
var StrsItem = KMXPlus.StrsItem;
;
;
export function build_strs(source_strs) {
    const result = {
        ident: constants.hex_section_id(constants.section.strs),
        size: 0, // finalized later
        _offset: 0,
        count: source_strs.strings.length,
        items: [], // filled below
    };
    result.items = source_strs.strings.map(item => { return { _value: item.value, length: item.value.length, offset: 0 }; });
    result.items.sort((a, b) => StrsItem.binaryStringCompare(a._value, b._value));
    let offset = constants.length_strs + constants.length_strs_item * result.count;
    // TODO: consider padding
    for (const item of result.items) {
        item.offset = offset;
        offset += item.length * 2 + 2; /* UTF-16 code units + sizeof null terminator */
    }
    result.size = offset;
    return result;
}
/**
 * @returns str index, or UTF-32 char if value.char is set (single char)
 */
export function build_strs_index(sect_strs, value) {
    if (!(value instanceof StrsItem)) {
        if (value === null) {
            throw new Error('unexpected null StrsItem, use an empty string instead');
        }
        else {
            throw new Error('unexpected StrsItem value ' + value);
        }
    }
    if (value.isOneChar) {
        return value.char;
    }
    const result = sect_strs.items.findIndex(v => v._value === value.value);
    if (result < 0) {
        throw new Error('unexpectedly missing StrsItem ' + value.value);
    }
    return result;
}
//# sourceMappingURL=build-strs.js.map